#!/usr/bin/perl
#
#file: frames.pl

use CGI qw/:all/;
use CGI::Carp qw(fatalsToBrowser);
use POSIX qw(strftime);
use Time::Local;
#
$today = strftime("%a %b %d, %Y - %T", localtime(time));
$shadow_prefix = strftime("SHA%y%m%d.", localtime(time));
print header,
start_html(-title=>'Create an Incident Report',
           -author=>'Ima.Goodguy@goodguys.com',
           -background=>'/images/red_rock.gif');
if (!param) {
   print h3({-align=>CENTER}, 
   start_form(-target=>'_self'),
   "Naval Surface Warfare Center/Dahlgren Division - Network Detection Report"),
   "SHADOW Report No.: ",
   textfield(-name=>'rep_num',
             -size=>15,
             -value=>$shadow_prefix),
   p(),
   "   Mail Recipients: ",
   textfield(-name=>'mailto',
             -size=>60,
             -value=>'SHADOW_mail_list'),
   p(),
   "1. Report Date: $today", 
   p(),
   "2. Incident Date: ",
   textfield(-name=>'inci_date',
             -size=>20),
   p(),
   "3. Type of Incident: ",
   scrolling_list(-name=>'inci_type',
                  -size=>1,
                  -values=>['Denial of Service Attack', 'Smurf Attack',
                  'Land Attack', 'IMAP Attack', 'Telnet Attack', 'Port Scan',
                  'RPC/Portmap Attack', 'Sendmail Attack', 'Boogie-Man Attack',
                  'Heart Attack', 'A Tic Attack', 'Knight Attack', 
                  'Pre-Dawn Attack', 'Attack of the Killer Tomatoes',
                  'Network Mapping Attempt', 'Unknown Probe type',
                  'SYN Flood']),
   p(),
   "4. Individuals Involved: Source: ",
   textfield(-name=>'indi_source',
             -size=>35),
   "Target(s): ",
   textfield(-name=>'indi_target',
             -size=>35),
   p(),
   "5. Cost of this Incident: ",
   textfield(-name=>'inci_cost',
             -size=>70,
             -value=>'0.25 Hours, No Downtime, Stopped at Firewall'),
   p(),
   "6. Summary of Incident and Investigation Results: ",
   textarea(-name=>'summary',
            -rows=>10,
            -cols=>90,
            -wrap=>'physical'),
   p(),
   submit,
   end_form;
} else {
   $rep_num = param('rep_num');
   $inci_date = param('inci_date');
   $inci_type = param('inci_type');
   $indi_source = param('indi_source');
   $indi_target = param('indi_target');
   $inci_cost = param('inci_cost');
   $inci_summ = param('summary');
   $inci_summ =~ tr/\r//d;
#   open(MAILFILE, '|/bin/mail -s "$inci_type" SHADOW_mail_list');
   open(MAILFILE, ">/tmp/IRmail$$");
   print MAILFILE <<"EOF";
         Naval Surface Warfare Center/Dahlgren Division 
                   Network Detection Report

          PHONE DSN 249-8884 COMMERCIAL 540-653-8884      

SHADOW Report No.: $rep_num

   1. Report Date: $today
   2. Incident Date: $inci_date
   3. Type of Incident: $inci_type
   4. Individuals Involved: 
         Source: $indi_source
         Target(s): $indi_target
   5. Cost of this Incident: $inci_cost
   6. Summary of Incident and Investigation Results: 

$inci_summ
EOF
   close(MAILFILE);
#
   print h3({-align=>CENTER},"Naval Surface Warfare Center/Dahlgren Division"),
         h3({-align=>CENTER}," Network Detection Report"), 
         p(),
         hr(),
         center(strong("PHONE DSN 249-8884 COMMERCIAL 540-653-8884")), 
         p(),
         center(strong("SHADOW Report No.:")," $rep_num"), p(),
         hr(),
         p(),
         strong("1. Report Date: "), "$today", p(),
         strong("2. Incident Date: "), "$inci_date", p(),
         strong("3. Type of Incident: "), "$inci_type", p(),
         strong("4. Individuals Involved: "), p(),
         ul(
         li(strong("Source: "), "$indi_source"), 
         li(strong("Target(s): "), "$indi_target"),
         ),
         strong("5. Cost of this Incident: "),"$inci_cost", p(),
         p(),
         strong("6. Summary of Incident and Investigation Results: "), p(),
         p(),
         pre("$inci_summ"), p(),
         hr(),
         h3({-align=>CENTER}," Mail sent.");
}
print end_html;
